// CameraDetection.as stuff
enum CameraDetectionMode {
    On,
    Auto,
    Off
}

[Setting category="Advanced" name="Use advanced cam3 detection" description="Advanced detection requires some spicy code due to engine limitations. AUTO will only use this code if it's been manually verified as working. Without advanced detection, a less-accurate fallback will be used."]
CameraDetectionMode useCameraDetection = CameraDetectionMode::Auto;

// NORMAL

[Setting category="Advanced" min=0 max=5000 drag name="Horizontal Distance" description="How far apart the left and right columns are"]
uint diegeticHorizontalDistance = 1000;

[Setting category="Advanced" min=0 max=5 drag name="Line Spacing" description="How far apart to place each row"]
float diegeticLineSpacing = 0.75;

[Setting category="Advanced" min=50 max=200 drag name="Letter Spacing" description="How much spacing to put between each character"]
float diegeticLetterSpacing = 110.0;

[Setting category="Advanced" name="Custom offset" description="Advanced adjustment, good luck!"]
vec3 diegeticCustomOffset = vec3(0,0,0);

[Setting category="Advanced" name="Scale" description="Advanced adjustment, good luck!"]
float diegeticScale = 1.0;

// CAM 3

[Setting category="Advanced" min=0 max=5000 drag name="Cam3 Horizontal Distance" description="How far apart the left and right columns are"]
uint diegeticHorizontalDistanceCam3 = 300;

[Setting category="Advanced" min=0 max=5 drag name="Cam3 Line Spacing" description="How far apart to place each row"]
float diegeticLineSpacingCam3 = 0.375;

[Setting category="Advanced" min=50 max=200 drag name="Cam3 Letter Spacing" description="How much spacing to put between each character"]
float diegeticLetterSpacingCam3 = 110.0;

[Setting category="Advanced" name="Cam3 Custom offset" description="Advanced adjustment, good luck!"]
vec3 diegeticCustomOffsetCam3 = vec3(0,1000,1);

[Setting category="Advanced" name="Cam3 Scale" description="Advanced adjustment, good luck!"]
float diegeticScaleCam3 = 0.4;


// CAM 3 ALT

[Setting category="Advanced" min=0 max=5000 drag name="Cam3Alt Horizontal Distance" description="How far apart the left and right columns are"]
uint diegeticHorizontalDistanceCam3a = 300;

[Setting category="Advanced" min=0 max=5 drag name="Cam3Alt Line Spacing" description="How far apart to place each row"]
float diegeticLineSpacingCam3a = 0.250;

[Setting category="Advanced" min=50 max=200 drag name="Cam3Alt Letter Spacing" description="How much spacing to put between each character"]
float diegeticLetterSpacingCam3a = 110.0;

[Setting category="Advanced" name="Cam3Alt Custom offset" description="Advanced adjustment, good luck!"]
vec3 diegeticCustomOffsetCam3a = vec3(0,750,2);

[Setting category="Advanced" name="Cam3Alt Scale" description="Advanced adjustment, good luck!"]
float diegeticScaleCam3a = 0.4;
